package {
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.filters.BitmapFilter;
	import flash.filters.BitmapFilterQuality;
	import flash.filters.DropShadowFilter;
	import flash.geom.Matrix;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;

	[SWF(width="400", height="300", frameRate="30", backgroundColor="0x00aaaa")]
	public class TextFieldTest extends Sprite
	{
		private var MOUSE_DOWN_MOVE:int = 3
		private var textSprite:Sprite;
		
		public function TextFieldTest(){
			this.x = 100;
			this.y = 100;
			textSprite = new Sprite();
			
			//automatically shows a hand as mouse cursor when the mouse hovers over the text field
			textSprite.buttonMode = true;
			
			addChild(textSprite);
			var labelType : TextField = new TextField();
			labelType.text = "Text in a line.";
			labelType.autoSize = TextFieldAutoSize.LEFT;
			labelType.wordWrap = true;
			
			labelType.filters 
			
			//copy TextField into a bitmap
			var typeTextBitmap : BitmapData = new BitmapData(labelType.width, labelType.height,true,0x00000000);
			typeTextBitmap.draw(labelType);
			
			//calculate center of TextField
			var typeTextTranslationX:Number = -0.5*labelType.width;
			var typeTextTranslationY:Number = -0.5*labelType.height;
//			
//			//create Matrix which moves the TextField to the center
			var matrix:Matrix = new Matrix();
			matrix.translate(typeTextTranslationX, typeTextTranslationY);
			
			//draw invisible rect in the background that will serve as click area
			textSprite.graphics.beginFill(0xfff0000,0);
			textSprite.graphics.drawRect(-0.5*labelType.width,-0.5*labelType.height, labelType.width, labelType.height);
			textSprite.graphics.endFill();
			
			//actually draw the text on the stage (with no-repeat and anti-aliasing)
			textSprite.graphics.beginBitmapFill(typeTextBitmap,matrix,false,true);
			textSprite.graphics.drawRect(typeTextTranslationX, typeTextTranslationY, labelType.width, labelType.height);
			textSprite.graphics.endFill();
			
			textSprite.addEventListener(MouseEvent.ROLL_OVER, onRollOver);
			textSprite.addEventListener(MouseEvent.ROLL_OUT, onRollOut);
			textSprite.addEventListener(MouseEvent.CLICK, onClick);
			textSprite.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
		}
		private function onRollOver(event:MouseEvent):void{
			var filterArray:Array = new Array();
			filterArray.push(getDropShadowFilterOver());
			textSprite.filters = filterArray;
		}
		private function onRollOut(event:MouseEvent):void{
			textSprite.filters = null;
		}
		private function onClick(event:MouseEvent):void{
			trace(this, "has been clicked.");
		}
		private function onMouseDown(event:MouseEvent):void{
			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			var filterArray:Array = new Array();
			filterArray.push(getDropShadowFilterOver());
			filterArray.push(getDropShadowFilterDown());
			textSprite.filters = filterArray;
		}
		private function onMouseUp(event:MouseEvent):void{
			stage.removeEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			var filterArray:Array = new Array();
			filterArray.push(getDropShadowFilterOver());
			textSprite.filters = filterArray;
		}
		public function getDropShadowFilterOver():BitmapFilter {
            var color:Number = 0x000000;
            var angle:Number = 0;
            var alpha:Number = 0.8;
            var blurX:Number = 8;
            var blurY:Number = 8;
            var distance:Number = 3;
            var strength:Number = 0.5;
            var inner:Boolean = false;
            var knockout:Boolean = false;
            var quality:Number = BitmapFilterQuality.HIGH;
            return new DropShadowFilter(distance,
                                        angle,
                                        color,
                                        alpha,
                                        blurX,
                                        blurY,
                                        strength,
                                        quality,
                                        inner,
                                        knockout);
        }
        
        public function getDropShadowFilterDown():BitmapFilter {
            var color:Number = 0xff0000;
            var angle:Number = 0;
            var alpha:Number = 0.8;
            var blurX:Number = 20;
            var blurY:Number = 20;
            var distance:Number = 0;
            var strength:Number = 1;
            var inner:Boolean = false;
            var knockout:Boolean = false;
            var quality:Number = BitmapFilterQuality.HIGH;
            return new DropShadowFilter(distance,
                                        angle,
                                        color,
                                        alpha,
                                        blurX,
                                        blurY,
                                        strength,
                                        quality,
                                        inner,
                                        knockout);
        }
	}
}
